package pro.litvinovg.w2phtml.gui;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.UIManager;

import com.sun.star.uno.XComponentContext;

import pro.litvinovg.xml.Debug;
import w2phtml.Application;

import java.awt.Toolkit;
import java.awt.GridLayout;
import javax.swing.JTabbedPane;
import javax.swing.JMenuBar;
import javax.swing.JOptionPane;
import javax.swing.JMenu;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JCheckBox;
import javax.swing.JTextField;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.GroupLayout.ParallelGroup;
import javax.swing.GroupLayout.SequentialGroup;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.JRadioButton;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.HashMap;
import java.util.Set;
import java.awt.event.ActionEvent;
import javax.swing.JSplitPane;
import java.awt.BorderLayout;
import javax.swing.JDesktopPane;
import javax.swing.BoxLayout;
import javax.swing.SpringLayout;
import java.awt.FlowLayout;
import java.awt.CardLayout;
import java.awt.Component;

import javax.swing.SwingConstants;
import javax.swing.JComboBox;

public class ConfigurationWindow extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static JFrame singleFrame = null;


	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {

		runGUI(null);
	}

	private XComponentContext context;
	private String fileName = "";

	/**
	 * Create the application.
	 */
	public ConfigurationWindow() {
		setTitle("Converter from ODT to HTML, ePub and RDF");
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setIconImage(Toolkit.getDefaultToolkit().getImage(ConfigurationWindow.class.getResource("/pro/litvinovg/w2phtml/gui/resources/w2phtml.png")));
		initComponents();
		createEvents();
	}
	
	public ConfigurationWindow(XComponentContext context, ODTDocument doc) {
		this.context = context;
		fileName = doc.getFileName();
		setTitle("Converter from ODT to HTML, ePub and RDF");
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setIconImage(Toolkit.getDefaultToolkit().getImage(ConfigurationWindow.class.getResource("/pro/litvinovg/w2phtml/gui/resources/w2phtml.png")));
		initComponents();
		createEvents();
	}

	private void createEvents() {
		// TODO Auto-generated method stub
		
	}

	private void initComponents() {

		getContentPane().setLayout(new GridLayout(1, 0, 0, 0));

		JTabbedPane tabbedPane = new JTabbedPane(JTabbedPane.LEFT);
		getContentPane().add(tabbedPane);

		JPanel panel_rdf = createRDFPanel();
		JPanel panel_epub = createEpubPanel(); 
		JPanel panel_html = createHTMLPanel();
		 
		
		tabbedPane.addTab("HTML", null, panel_html, null);
		tabbedPane.addTab("RDF", null, panel_rdf, null);
		tabbedPane.addTab("ePub", null, panel_epub, null);
		 
	}

	private JPanel createEpubPanel() {
		JPanel panel_epub = new JPanel();
		HashMap<String, Component> configuration = new HashMap<String, Component>();
		JPanel panel_control = createControlPanel(configuration);
		JPanel panel_configEpub = createConfigEpubPanel(configuration);
		applyDefaultLayout(panel_epub, panel_configEpub, panel_control);
		return panel_epub;
	}

	private JPanel createRDFPanel() {
		JPanel panel_rdf = new JPanel();
		HashMap<String, Component> configuration = new HashMap<String, Component>();
		JPanel panel_control = createControlPanel(configuration);
		JPanel panel_configRDF = createConfigRDFPanel(configuration);
		applyDefaultLayout2(panel_rdf, panel_configRDF, panel_control);
		return panel_rdf;
	}

	private JPanel createHTMLPanel() {
		JPanel panel_html = new JPanel();
		HashMap<String, Component> configuration = new HashMap<String, Component>();
		JPanel panel_configHTML = createConfigHTMLPanel(configuration);
		JPanel panel_control = createControlPanel(configuration);
		applyDefaultLayout3(panel_html, panel_configHTML, panel_control);
		return panel_html;
	}

	private void applyDefaultLayout(JPanel tabbedPanel, JPanel configPanel, JPanel controlPanel) {
		
		GroupLayout gl_panel_html = new GroupLayout(tabbedPanel);
		gl_panel_html.setHorizontalGroup(gl_panel_html.createParallelGroup(Alignment.TRAILING)
				.addGroup(gl_panel_html.createSequentialGroup().addGroup(gl_panel_html.createParallelGroup(Alignment.TRAILING)
						.addComponent(configPanel, GroupLayout.DEFAULT_SIZE, 852, Short.MAX_VALUE).addComponent(controlPanel, GroupLayout.DEFAULT_SIZE, 852, Short.MAX_VALUE)).addGap(4)));
		gl_panel_html.setVerticalGroup(gl_panel_html.createParallelGroup(Alignment.LEADING).addGroup(Alignment.TRAILING,
				gl_panel_html.createSequentialGroup()
				.addComponent(configPanel, GroupLayout.DEFAULT_SIZE, 691, Short.MAX_VALUE)
				.addPreferredGap(ComponentPlacement.RELATED)
				.addComponent(controlPanel, GroupLayout.PREFERRED_SIZE, 48, GroupLayout.PREFERRED_SIZE)));
		tabbedPanel.setLayout(gl_panel_html);
	}
	private void applyDefaultLayout2(JPanel tabbedPanel, JPanel configPanel, JPanel controlPanel) {
		
		GroupLayout gl_panel_html = new GroupLayout(tabbedPanel);
		gl_panel_html.setHorizontalGroup(gl_panel_html.createParallelGroup(Alignment.TRAILING)
				.addGroup(gl_panel_html.createSequentialGroup().addGroup(gl_panel_html.createParallelGroup(Alignment.TRAILING)
						.addComponent(configPanel, GroupLayout.DEFAULT_SIZE, 852, Short.MAX_VALUE).addComponent(controlPanel, GroupLayout.DEFAULT_SIZE, 852, Short.MAX_VALUE)).addGap(4)));
		gl_panel_html.setVerticalGroup(gl_panel_html.createParallelGroup(Alignment.LEADING).addGroup(Alignment.TRAILING,
				gl_panel_html.createSequentialGroup()
				.addComponent(configPanel, GroupLayout.DEFAULT_SIZE, 691, Short.MAX_VALUE)
				.addPreferredGap(ComponentPlacement.RELATED)
				.addComponent(controlPanel, GroupLayout.PREFERRED_SIZE, 48, GroupLayout.PREFERRED_SIZE)));
		tabbedPanel.setLayout(gl_panel_html);
	}
	private void applyDefaultLayout3(JPanel tabbedPanel, JPanel configPanel, JPanel controlPanel) {
		
		GroupLayout gl_panel_html = new GroupLayout(tabbedPanel);
		gl_panel_html.setHorizontalGroup(gl_panel_html.createParallelGroup(Alignment.TRAILING)
				.addGroup(gl_panel_html.createSequentialGroup().addGroup(gl_panel_html.createParallelGroup(Alignment.TRAILING)
						.addComponent(configPanel, GroupLayout.DEFAULT_SIZE, 852, Short.MAX_VALUE).addComponent(controlPanel, GroupLayout.DEFAULT_SIZE, 852, Short.MAX_VALUE)).addGap(4)));
		gl_panel_html.setVerticalGroup(gl_panel_html.createParallelGroup(Alignment.LEADING).addGroup(Alignment.TRAILING,
				gl_panel_html.createSequentialGroup()
				.addComponent(configPanel, GroupLayout.DEFAULT_SIZE, 691, Short.MAX_VALUE)
				.addPreferredGap(ComponentPlacement.RELATED)
				.addComponent(controlPanel, GroupLayout.PREFERRED_SIZE, 48, GroupLayout.PREFERRED_SIZE)));
		tabbedPanel.setLayout(gl_panel_html);
	}

	
	private JPanel createConfigEpubPanel(HashMap<String, Component> configuration) {
		JPanel panel_configHTML = new JPanel();
		
		JCheckBox cb_UseMathJax = new JCheckBox("Use MathJax");
		cb_UseMathJax.setSelected(true);
		configuration.put("use_mathjax", cb_UseMathJax);

		JCheckBox cb_IgnoreEmptyParagraphs = new JCheckBox("Filter empty paragraphs");
		cb_IgnoreEmptyParagraphs.setSelected(true);
		configuration.put("ignore_empty_paragraphs", cb_IgnoreEmptyParagraphs);

		JCheckBox cb_IgnoreHardLineBreaks = new JCheckBox("Filter hard line breaks");
		cb_IgnoreHardLineBreaks.setSelected(true);
		configuration.put("ignore_hard_line_breaks", cb_IgnoreHardLineBreaks);

		JLabel lb_FilterLetterSpacing = new JLabel("Filter letter spacing less than");

		JTextField tf_FilterLetterSpacing = new JTextField();
		tf_FilterLetterSpacing.setText("0.15");
		configuration.put("min_letter_spacing", tf_FilterLetterSpacing);

		tf_FilterLetterSpacing.setColumns(10);

		JCheckBox cb_InlineStyles = new JCheckBox("Inline styles");
		cb_InlineStyles.setSelected(true);
		configuration.put("css_inline", cb_InlineStyles);

		JCheckBox cb_EmbedVectorImages = new JCheckBox("Embed vector images");
		cb_EmbedVectorImages.setSelected(true);
		configuration.put("embed_svg", cb_EmbedVectorImages);

		JCheckBox cb_EmbedRaster = new JCheckBox("Embed raster images");
		cb_EmbedRaster.setSelected(true);
		configuration.put("embed_img", cb_EmbedRaster);

		JLabel lb_Scale = new JLabel("Scale");
		JTextField tf_Scale = new JTextField();
		tf_Scale.setText("100%");
		configuration.put("scaling", tf_Scale);

		tf_Scale.setColumns(10);

		JCheckBox cb_convertToPx = new JCheckBox("Convert dimensions to pixels instead of REM (root em)");
		configuration.put("convert_to_px", cb_convertToPx);
		
		JLabel lb_FilePath = new JLabel("Input file path");
		
		JTextField tf_inputFile = new JTextField(fileName);
		tf_inputFile.setColumns(10);
		configuration.put("inputFile", tf_inputFile);

		
		JLabel lb_TargetFormat = new JLabel("epub3");
		configuration.put("targetFormat", lb_TargetFormat);

		
		JLabel lb_TargetFormat_description = new JLabel("Target format");
		JTextField tf_OutputFile = new JTextField("");
		configuration.put("outputFile", tf_OutputFile);
		tf_OutputFile.setColumns(10);
		
		JButton btnChooseFile = new JButton("Choose");
		btnChooseFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				FileDialog fileDialog = new FileDialog();
				String newFilePath = fileDialog.chooseFile(tf_inputFile.getText(),"odt");
				if (newFilePath != null && !newFilePath.isEmpty()) {
					tf_inputFile.setText(newFilePath);
					setOutputFilePath(newFilePath,tf_OutputFile,"epub");

				}
			}
		});

		
		JButton btn_ChooseOutputFile = new JButton("Choose");
		btn_ChooseOutputFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				FileDialog fileDialog = new FileDialog();
				String newFilePath = fileDialog.chooseFile(tf_OutputFile.getText(),"epub");
				if (newFilePath != null && !newFilePath.isEmpty()) {
					tf_OutputFile.setText(newFilePath);
				}
			}
		});
		

		
		JLabel lb_OutFilePath = new JLabel("Output file path");
		
		JLabel lb_pageBreakInlineStyle = new JLabel("Page break inline style");
		
		JTextField tf_pageBreakInlineStyle = new JTextField();
		configuration.put("page_break_style", tf_pageBreakInlineStyle);
		tf_pageBreakInlineStyle.setText("height:3em;margin-top:1em;margin-bottom:1em;background-color:#f6f6f6;");
		tf_pageBreakInlineStyle.setColumns(10);
		
		JCheckBox cb_Pagination = new JCheckBox("Pagination");
		cb_Pagination.setSelected(true);
		configuration.put("pagination", cb_Pagination);

		GroupLayout gl_panel_configHTML = new GroupLayout(panel_configHTML);
		gl_panel_configHTML.setHorizontalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addGap(32)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addComponent(cb_Pagination, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
							.addContainerGap())
						.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
							.addGroup(gl_panel_configHTML.createSequentialGroup()
								.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addComponent(lb_Scale, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE)
										.addGap(18)
										.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE))
									.addComponent(cb_UseMathJax, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addComponent(lb_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 253, GroupLayout.PREFERRED_SIZE)
										.addGap(18)
										.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 58, GroupLayout.PREFERRED_SIZE))
									.addComponent(cb_convertToPx, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_IgnoreHardLineBreaks, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_IgnoreEmptyParagraphs, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_EmbedRaster, GroupLayout.PREFERRED_SIZE, 194, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_EmbedVectorImages, GroupLayout.PREFERRED_SIZE, 214, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_InlineStyles, GroupLayout.PREFERRED_SIZE, 156, GroupLayout.PREFERRED_SIZE))
								.addContainerGap())
							.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
								.addGroup(gl_panel_configHTML.createSequentialGroup()
									.addComponent(lb_pageBreakInlineStyle, GroupLayout.PREFERRED_SIZE, 191, GroupLayout.PREFERRED_SIZE)
									.addPreferredGap(ComponentPlacement.RELATED)
									.addComponent(tf_pageBreakInlineStyle, GroupLayout.DEFAULT_SIZE, 697, Short.MAX_VALUE)
									.addGap(32))
								.addGroup(gl_panel_configHTML.createSequentialGroup()
									.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
										.addGroup(gl_panel_configHTML.createSequentialGroup()
											.addComponent(lb_OutFilePath, GroupLayout.PREFERRED_SIZE, 131, GroupLayout.PREFERRED_SIZE)
											.addPreferredGap(ComponentPlacement.RELATED)
											.addComponent(tf_OutputFile, GroupLayout.DEFAULT_SIZE, 616, Short.MAX_VALUE)
											.addGap(12)
											.addComponent(btn_ChooseOutputFile, GroupLayout.PREFERRED_SIZE, 113, GroupLayout.PREFERRED_SIZE))
										.addGroup(gl_panel_configHTML.createSequentialGroup()
											.addComponent(lb_TargetFormat_description, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE)
											.addPreferredGap(ComponentPlacement.UNRELATED)
											.addComponent(lb_TargetFormat, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE))
										.addGroup(gl_panel_configHTML.createSequentialGroup()
											.addComponent(lb_FilePath, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE)
											.addGap(32)
											.addComponent(tf_inputFile, GroupLayout.DEFAULT_SIZE, 616, Short.MAX_VALUE)
											.addGap(12)
											.addComponent(btnChooseFile, GroupLayout.PREFERRED_SIZE, 113, GroupLayout.PREFERRED_SIZE)))
									.addGap(48))))))
		);
		gl_panel_configHTML.setVerticalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addContainerGap()
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_TargetFormat_description)
						.addComponent(lb_TargetFormat))
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(24)
							.addComponent(lb_FilePath))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(22)
							.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
								.addComponent(tf_inputFile, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
								.addComponent(btnChooseFile))))
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(18)
							.addComponent(btn_ChooseOutputFile))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(21)
							.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
								.addComponent(tf_OutputFile, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
								.addComponent(lb_OutFilePath))))
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_pageBreakInlineStyle)
						.addComponent(tf_pageBreakInlineStyle, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_Scale))
						.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(8)
							.addComponent(lb_FilterLetterSpacing)
							.addGap(4)
							.addComponent(cb_InlineStyles)
							.addGap(7)
							.addComponent(cb_EmbedVectorImages)
							.addGap(7)
							.addComponent(cb_EmbedRaster))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(6)
							.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)))
					.addGap(7)
					.addComponent(cb_convertToPx)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(cb_IgnoreHardLineBreaks)
					.addGap(7)
					.addComponent(cb_IgnoreEmptyParagraphs)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_UseMathJax)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_Pagination)
					.addContainerGap(271, Short.MAX_VALUE))
		);
		panel_configHTML.setLayout(gl_panel_configHTML);
		return panel_configHTML;
	}
	
	
	private JPanel createConfigHTMLPanel(HashMap<String, Component> configuration) {
		JPanel panel_configHTML = new JPanel();
		
		JCheckBox cb_UseMathJax = new JCheckBox("Use MathJax");
		cb_UseMathJax.setSelected(true);
		configuration.put("use_mathjax", cb_UseMathJax);

		JCheckBox cb_SplitWholePagesOnly = new JCheckBox("Split on whole pages only");
		configuration.put("align_splits_to_pages", cb_SplitWholePagesOnly);

		JLabel lb_SplitByLevel = new JLabel("Split into multiple files by heading level");
		JTextField tf_SplitByLevel = new JTextField();
		configuration.put("split_level", tf_SplitByLevel);

		tf_SplitByLevel.setColumns(10);

		JCheckBox cb_Greenstone = new JCheckBox("Split document into subsections for Greenstone digital library");
		configuration.put("greenstone", cb_Greenstone);

		JCheckBox cb_IgnoreEmptyParagraphs = new JCheckBox("Filter empty paragraphs");
		cb_IgnoreEmptyParagraphs.setSelected(true);
		configuration.put("ignore_empty_paragraphs", cb_IgnoreEmptyParagraphs);

		JCheckBox cb_IgnoreHardLineBreaks = new JCheckBox("Filter hard line breaks");
		cb_IgnoreHardLineBreaks.setSelected(true);
		configuration.put("ignore_hard_line_breaks", cb_IgnoreHardLineBreaks);

		JLabel lb_FilterLetterSpacing = new JLabel("Filter letter spacing less than");

		JTextField tf_FilterLetterSpacing = new JTextField();
		tf_FilterLetterSpacing.setText("0.15");
		configuration.put("min_letter_spacing", tf_FilterLetterSpacing);

		tf_FilterLetterSpacing.setColumns(10);

		JCheckBox cb_InlineStyles = new JCheckBox("Inline styles");
		cb_InlineStyles.setSelected(true);
		configuration.put("css_inline", cb_InlineStyles);

		JCheckBox cb_EmbedVectorImages = new JCheckBox("Embed vector images");
		cb_EmbedVectorImages.setSelected(true);
		configuration.put("embed_svg", cb_EmbedVectorImages);

		JCheckBox cb_EmbedRaster = new JCheckBox("Embed raster images");
		cb_EmbedRaster.setSelected(true);
		configuration.put("embed_img", cb_EmbedRaster);

		JLabel lb_Scale = new JLabel("Scale");
		JTextField tf_Scale = new JTextField();
		tf_Scale.setText("100%");
		configuration.put("scaling", tf_Scale);

		tf_Scale.setColumns(10);

		JLabel lb_MaxWidth = new JLabel("Max body width");

		JTextField tf_MaxWidth = new JTextField();
		configuration.put("max_width", tf_MaxWidth);

		tf_MaxWidth.setColumns(10);

		JCheckBox cb_convertToPx = new JCheckBox("Convert dimensions to pixels instead of REM (root em)");
		configuration.put("convert_to_px", cb_convertToPx);
		
		JLabel lb_FilePath = new JLabel("Input file path");
		
		JTextField tf_inputFile = new JTextField(fileName);
		tf_inputFile.setColumns(10);
		configuration.put("inputFile", tf_inputFile);

		
		JLabel lb_TargetFormat = new JLabel("html5");
		configuration.put("targetFormat", lb_TargetFormat);
		JLabel lb_TargetFormat_description = new JLabel("Target format");
		
		JLabel lb_OutFilePath = new JLabel("Output file path");
		JTextField tf_OutputFile = new JTextField("");
		tf_OutputFile.setColumns(10);
		configuration.put("outputFile", tf_OutputFile);
		
		JButton btn_ChooseInputFile = new JButton("Choose");
		btn_ChooseInputFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				FileDialog fileDialog = new FileDialog();
				String newFilePath = fileDialog.chooseFile(tf_inputFile.getText(),"odt");
				if (newFilePath != null && !newFilePath.isEmpty()) {
					tf_inputFile.setText(newFilePath);
					setOutputFilePath(newFilePath,tf_OutputFile,"html");
				}
			}

			
		});
		
		JButton btn_ChooseOutputFile = new JButton("Choose");
		btn_ChooseOutputFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				FileDialog fileDialog = new FileDialog();
				String newFilePath = fileDialog.chooseFile(tf_OutputFile.getText(),"html");
				if (newFilePath != null && !newFilePath.isEmpty()) {
					tf_OutputFile.setText(newFilePath);
				}
			}
		});
		
		JTextField tf_pageBreakInlineStyle = new JTextField();
		configuration.put("page_break_style", tf_pageBreakInlineStyle);
		tf_pageBreakInlineStyle.setText("height:3em;margin-top:1em;margin-bottom:1em;background-color:#f6f6f6;");
		tf_pageBreakInlineStyle.setColumns(10);
		
		JLabel lb_pageBreakInlineStyle = new JLabel("Page break inline style");
		
		JCheckBox cb_Pagination = new JCheckBox("Pagination");
		cb_Pagination.setSelected(true);
		configuration.put("pagination", cb_Pagination);

		GroupLayout gl_panel_configHTML = new GroupLayout(panel_configHTML);
		gl_panel_configHTML.setHorizontalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addGap(32)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addComponent(cb_Pagination, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
							.addContainerGap())
						.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
							.addGroup(gl_panel_configHTML.createSequentialGroup()
								.addComponent(lb_pageBreakInlineStyle, GroupLayout.PREFERRED_SIZE, 191, GroupLayout.PREFERRED_SIZE)
								.addPreferredGap(ComponentPlacement.RELATED)
								.addComponent(tf_pageBreakInlineStyle, GroupLayout.DEFAULT_SIZE, 717, Short.MAX_VALUE)
								.addContainerGap())
							.addGroup(gl_panel_configHTML.createSequentialGroup()
								.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
									.addComponent(lb_FilePath, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE)
									.addComponent(lb_OutFilePath, GroupLayout.PREFERRED_SIZE, 131, GroupLayout.PREFERRED_SIZE))
								.addPreferredGap(ComponentPlacement.RELATED)
								.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addComponent(tf_OutputFile, GroupLayout.DEFAULT_SIZE, 652, Short.MAX_VALUE)
										.addPreferredGap(ComponentPlacement.UNRELATED)
										.addComponent(btn_ChooseOutputFile, GroupLayout.PREFERRED_SIZE, 113, GroupLayout.PREFERRED_SIZE))
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addComponent(tf_inputFile, GroupLayout.DEFAULT_SIZE, 652, Short.MAX_VALUE)
										.addPreferredGap(ComponentPlacement.UNRELATED)
										.addComponent(btn_ChooseInputFile, GroupLayout.PREFERRED_SIZE, 113, GroupLayout.PREFERRED_SIZE)))
								.addContainerGap())
							.addGroup(gl_panel_configHTML.createSequentialGroup()
								.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
									.addComponent(cb_UseMathJax, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addComponent(lb_Scale, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE)
										.addGap(18)
										.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE))
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addComponent(lb_MaxWidth)
										.addGap(18)
										.addComponent(tf_MaxWidth, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE))
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addComponent(lb_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 253, GroupLayout.PREFERRED_SIZE)
										.addGap(18)
										.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 58, GroupLayout.PREFERRED_SIZE))
									.addComponent(cb_convertToPx, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_IgnoreHardLineBreaks, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_IgnoreEmptyParagraphs, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_Greenstone, GroupLayout.PREFERRED_SIZE, 482, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_SplitWholePagesOnly, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_EmbedRaster, GroupLayout.PREFERRED_SIZE, 194, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_EmbedVectorImages, GroupLayout.PREFERRED_SIZE, 214, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_InlineStyles, GroupLayout.PREFERRED_SIZE, 156, GroupLayout.PREFERRED_SIZE)
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addComponent(lb_TargetFormat_description, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE)
										.addPreferredGap(ComponentPlacement.UNRELATED)
										.addComponent(lb_TargetFormat, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE))
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addComponent(lb_SplitByLevel, GroupLayout.PREFERRED_SIZE, 295, GroupLayout.PREFERRED_SIZE)
										.addGap(42)
										.addComponent(tf_SplitByLevel, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE)))
								.addGap(340)))))
		);
		gl_panel_configHTML.setVerticalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addContainerGap()
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_TargetFormat_description)
						.addComponent(lb_TargetFormat))
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_FilePath))
						.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
							.addComponent(tf_inputFile, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
							.addComponent(btn_ChooseInputFile)))
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_OutFilePath)
						.addComponent(tf_OutputFile, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						.addComponent(btn_ChooseOutputFile))
					.addGap(12)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_pageBreakInlineStyle)
						.addComponent(tf_pageBreakInlineStyle, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_Scale))
						.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(6)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_MaxWidth))
						.addComponent(tf_MaxWidth, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(8)
							.addComponent(lb_FilterLetterSpacing)
							.addGap(4)
							.addComponent(cb_InlineStyles)
							.addGap(7)
							.addComponent(cb_EmbedVectorImages)
							.addGap(7)
							.addComponent(cb_EmbedRaster))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(6)
							.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)))
					.addGap(7)
					.addComponent(cb_convertToPx)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(cb_IgnoreHardLineBreaks)
					.addGap(7)
					.addComponent(cb_IgnoreEmptyParagraphs)
					.addGap(4)
					.addComponent(cb_Greenstone)
					.addGap(8)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addComponent(tf_SplitByLevel, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_SplitByLevel)))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(cb_SplitWholePagesOnly)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_UseMathJax)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(cb_Pagination)
					.addContainerGap(235, Short.MAX_VALUE))
		);
		panel_configHTML.setLayout(gl_panel_configHTML);
		return panel_configHTML;
	}
	
	protected void setOutputFilePath(String newFilePath, JTextField tf_OutputFile, String extension) {
		
		File inputFile = new File(newFilePath);
		if (!inputFile.exists()) {
			return;
		}
		if (!inputFile.isDirectory()) {
			File parent = inputFile.getParentFile();
			if (parent == null) {
				return;
			}
			if (!parent.canWrite()){
				JOptionPane.showMessageDialog(singleFrame, "Attension. Can't save file in output directory.");
			}
		}
		if (newFilePath.length() < 3) {
			return;
		}
		String exportPath;
		if (inputFile.isDirectory()) {
			exportPath = newFilePath;	
			tf_OutputFile.setText(exportPath);
		} else {
			String importExt = newFilePath.substring(newFilePath.length()-3, newFilePath.length()).toLowerCase();
			if (importExt.equals("odt")) {
				exportPath = newFilePath.substring(0, newFilePath.length()-3) + extension;	
				tf_OutputFile.setText(exportPath);
			}
		}
	}

	protected void setMetadataFilePath(String newFilePath, JTextField tf_MetadataFile, String extension) {
		
		File inputFile = new File(newFilePath);
		if (!inputFile.exists()) {
			return;
		}
		if (inputFile.isDirectory()) {
			tf_MetadataFile.setText(newFilePath);	
		} else {
			File parent = inputFile.getParentFile();
			if (parent == null) {
				return;
			}
			if (newFilePath.length() < 3) {
				return;
			}
			String importExt = newFilePath.substring(newFilePath.length()-3, newFilePath.length()).toLowerCase();
			if (importExt.equals("odt")) {
				String metadataPath = newFilePath.substring(0, newFilePath.length()-3) + extension;
				File metaFile = new File(metadataPath);
				if (metaFile.exists() && metaFile.canRead()){
					tf_MetadataFile.setText(metadataPath);	
				}	else {
					tf_MetadataFile.setText("");
				}
			}
		}
	}

	private JPanel createConfigRDFPanel(HashMap<String, Component> configuration) {
		JPanel panel_configHTML = new JPanel();
		
		JCheckBox cb_UseMathJax = new JCheckBox("Use MathJax");
		cb_UseMathJax.setSelected(true);
		configuration.put("use_mathjax", cb_UseMathJax);

		JCheckBox cb_IgnoreEmptyParagraphs = new JCheckBox("Filter empty paragraphs");
		cb_IgnoreEmptyParagraphs.setSelected(true);
		configuration.put("ignore_empty_paragraphs", cb_IgnoreEmptyParagraphs);

		JCheckBox cb_IgnoreHardLineBreaks = new JCheckBox("Filter hard line breaks");
		cb_IgnoreHardLineBreaks.setSelected(true);
		configuration.put("ignore_hard_line_breaks", cb_IgnoreHardLineBreaks);

		JLabel lb_FilterLetterSpacing = new JLabel("Filter letter spacing less than");

		JTextField tf_FilterLetterSpacing = new JTextField();
		tf_FilterLetterSpacing.setText("0.15");
		configuration.put("min_letter_spacing", tf_FilterLetterSpacing);

		tf_FilterLetterSpacing.setColumns(10);

		JCheckBox cb_InlineStyles = new JCheckBox("Inline styles");
		cb_InlineStyles.setEnabled(false);
		cb_InlineStyles.setSelected(true);
		configuration.put("css_inline", cb_InlineStyles);

		JCheckBox cb_EmbedVectorImages = new JCheckBox("Embed vector images");
		cb_EmbedVectorImages.setEnabled(false);
		cb_EmbedVectorImages.setSelected(true);
		configuration.put("embed_svg", cb_EmbedVectorImages);

		JCheckBox cb_EmbedRaster = new JCheckBox("Embed raster images");
		cb_EmbedRaster.setEnabled(false);
		cb_EmbedRaster.setSelected(true);
		configuration.put("embed_img", cb_EmbedRaster);

		JLabel lb_Scale = new JLabel("Scale");
		JTextField tf_Scale = new JTextField();
		tf_Scale.setText("100%");
		configuration.put("scaling", tf_Scale);

		tf_Scale.setColumns(10);

		JCheckBox cb_convertToPx = new JCheckBox("Convert dimensions to pixels instead of REM (root em)");
		configuration.put("convert_to_px", cb_convertToPx);
		
		JLabel lb_FilePath = new JLabel("Input file path");
		
		JTextField tf_inputFile = new JTextField(fileName);
		tf_inputFile.setColumns(10);
		configuration.put("inputFile", tf_inputFile);

		
		JLabel lb_TargetFormat = new JLabel("rdf");
		configuration.put("targetFormat", lb_TargetFormat);

		
		JLabel lb_TargetFormat_description = new JLabel("Target format");

		JLabel lb_OutFilePath = new JLabel("Output file path");
		
		JTextField tf_OutputFile = new JTextField("");
		configuration.put("outputFile", tf_OutputFile);
		tf_OutputFile.setColumns(10);
		
		String[] types = {"elenphArticle", "encArticle", "book", "journal"};
		JComboBox cbox_type = new JComboBox(types);
		configuration.put("rdf_type", cbox_type);

		
		JLabel lb_type = new JLabel("Type");
		
		JLabel lb_metadataFilePath = new JLabel("Metadata path");
		
		JTextField tf_metadataPath = new JTextField("");
		configuration.put("csv_metadata", tf_metadataPath);
		
		JButton btnChooseFile = new JButton("Choose");
		btnChooseFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				FileDialog fileDialog = new FileDialog();
				String newFilePath = fileDialog.chooseFile(tf_inputFile.getText(),"odt");
				if (newFilePath != null && !newFilePath.isEmpty()) {
					tf_inputFile.setText(newFilePath);
					setOutputFilePath(newFilePath,tf_OutputFile,"rdf");
					setMetadataFilePath(newFilePath,tf_metadataPath,"csv");
				}
			}
		});
		

		
		JButton btn_ChooseOutputFile = new JButton("Choose");
		btn_ChooseOutputFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				FileDialog fileDialog = new FileDialog();
				String newFilePath = fileDialog.chooseFile(tf_OutputFile.getText(),"rdf");
				if (newFilePath != null && !newFilePath.isEmpty()) {
					tf_OutputFile.setText(newFilePath);
				}
			}
		});


		tf_metadataPath.setColumns(10);
		
		JButton btn_metadataChoose = new JButton("Choose");
		btn_metadataChoose.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				FileDialog fileDialog = new FileDialog();
				String newFilePath = fileDialog.chooseFile(tf_metadataPath.getText(),"csv");
				if (newFilePath != null && !newFilePath.isEmpty()) {
					tf_metadataPath.setText(newFilePath);
				}
			}
		});
		
		JLabel lb_pageBreakInlineStyle = new JLabel("Page break inline style");
		
		JTextField tf_pageBreakInlineStyle = new JTextField();
		configuration.put("page_break_style", tf_pageBreakInlineStyle);

		tf_pageBreakInlineStyle.setText("height:3em;margin-top:1em;margin-bottom:1em;background-color:#f6f6f6;");
		tf_pageBreakInlineStyle.setColumns(10);
		
		JCheckBox cb_Pagination = new JCheckBox("Pagination");
		configuration.put("pagination", cb_Pagination);

		
		GroupLayout gl_panel_configHTML = new GroupLayout(panel_configHTML);
		gl_panel_configHTML.setHorizontalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.TRAILING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addGap(23)
					.addComponent(lb_pageBreakInlineStyle, GroupLayout.PREFERRED_SIZE, 191, GroupLayout.PREFERRED_SIZE)
					.addGap(12)
					.addComponent(tf_pageBreakInlineStyle, GroupLayout.DEFAULT_SIZE, 717, Short.MAX_VALUE)
					.addGap(21))
				.addGroup(Alignment.LEADING, gl_panel_configHTML.createSequentialGroup()
					.addGap(32)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addComponent(cb_Pagination, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
							.addContainerGap())
						.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
							.addGroup(gl_panel_configHTML.createSequentialGroup()
								.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addComponent(lb_type, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE)
										.addPreferredGap(ComponentPlacement.RELATED)
										.addComponent(cbox_type, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addComponent(lb_Scale, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE)
										.addPreferredGap(ComponentPlacement.RELATED)
										.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, 98, GroupLayout.PREFERRED_SIZE))
									.addComponent(cb_UseMathJax, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addComponent(lb_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 229, GroupLayout.PREFERRED_SIZE)
										.addPreferredGap(ComponentPlacement.RELATED)
										.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 58, GroupLayout.PREFERRED_SIZE))
									.addComponent(cb_convertToPx, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_IgnoreHardLineBreaks, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_IgnoreEmptyParagraphs, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_EmbedRaster, GroupLayout.PREFERRED_SIZE, 194, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_EmbedVectorImages, GroupLayout.PREFERRED_SIZE, 214, GroupLayout.PREFERRED_SIZE)
									.addComponent(cb_InlineStyles, GroupLayout.PREFERRED_SIZE, 156, GroupLayout.PREFERRED_SIZE))
								.addContainerGap())
							.addGroup(gl_panel_configHTML.createSequentialGroup()
								.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addComponent(lb_OutFilePath, GroupLayout.PREFERRED_SIZE, 125, GroupLayout.PREFERRED_SIZE)
										.addPreferredGap(ComponentPlacement.UNRELATED)
										.addComponent(tf_OutputFile, GroupLayout.DEFAULT_SIZE, 600, Short.MAX_VALUE)
										.addGap(6)
										.addComponent(btn_ChooseOutputFile, GroupLayout.PREFERRED_SIZE, 113, GroupLayout.PREFERRED_SIZE))
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addComponent(lb_TargetFormat_description, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE)
										.addPreferredGap(ComponentPlacement.UNRELATED)
										.addComponent(lb_TargetFormat, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE))
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
											.addGroup(gl_panel_configHTML.createSequentialGroup()
												.addComponent(lb_metadataFilePath, GroupLayout.PREFERRED_SIZE, 131, GroupLayout.PREFERRED_SIZE)
												.addPreferredGap(ComponentPlacement.RELATED)
												.addComponent(tf_metadataPath, GroupLayout.DEFAULT_SIZE, 600, Short.MAX_VALUE))
											.addGroup(gl_panel_configHTML.createSequentialGroup()
												.addComponent(lb_FilePath, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE)
												.addGap(32)
												.addComponent(tf_inputFile, GroupLayout.DEFAULT_SIZE, 600, Short.MAX_VALUE)))
										.addGap(6)
										.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
											.addComponent(btn_metadataChoose, GroupLayout.PREFERRED_SIZE, 113, GroupLayout.PREFERRED_SIZE)
											.addComponent(btnChooseFile, GroupLayout.PREFERRED_SIZE, 113, GroupLayout.PREFERRED_SIZE))))
								.addGap(70)))))
		);
		gl_panel_configHTML.setVerticalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addContainerGap()
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_TargetFormat_description)
						.addComponent(lb_TargetFormat))
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(24)
							.addComponent(lb_FilePath))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(22)
							.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
								.addComponent(tf_inputFile, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
								.addComponent(btnChooseFile))))
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(23)
							.addComponent(lb_metadataFilePath))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(21)
							.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
								.addComponent(tf_metadataPath, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
								.addComponent(btn_metadataChoose))))
					.addGap(29)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
							.addComponent(tf_OutputFile, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
							.addComponent(btn_ChooseOutputFile))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_OutFilePath)))
					.addGap(23)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_pageBreakInlineStyle))
						.addComponent(tf_pageBreakInlineStyle, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(18)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_type)
						.addComponent(cbox_type, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_Scale)
						.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_FilterLetterSpacing)
						.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(4)
					.addComponent(cb_InlineStyles)
					.addGap(7)
					.addComponent(cb_EmbedVectorImages)
					.addGap(7)
					.addComponent(cb_EmbedRaster)
					.addGap(7)
					.addComponent(cb_convertToPx)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(cb_IgnoreHardLineBreaks)
					.addGap(7)
					.addComponent(cb_IgnoreEmptyParagraphs)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_UseMathJax)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_Pagination)
					.addContainerGap(207, Short.MAX_VALUE))
		);
		panel_configHTML.setLayout(gl_panel_configHTML);
		return panel_configHTML;
	}

	private JPanel createControlPanel(HashMap<String,Component> configuration) {
		JPanel controlPanel = new JPanel();
		
		JButton btn_Exit = new JButton("Exit");
		btn_Exit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				singleFrame.setVisible(false);
				singleFrame.dispose();
			}
		});
		
		JButton btn_SaveAs = new JButton("Save As");
		btn_SaveAs.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent actionEvent) {
				JOptionPane.showMessageDialog(singleFrame, "Not implemented, yet.");
			}
		});
		JButton btn_Save = new JButton("Save");
		btn_Save.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent actionEvent) {
				JOptionPane.showMessageDialog(singleFrame, "Not implemented, yet.");
			}
		});
		JButton btn_startConversion = new JButton("Convert");
		btn_startConversion.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent actionEvent) {
				try {
				ConversionExecutor executor = new ConversionExecutor(configuration, singleFrame);
					executor.convert();
				} catch(Throwable e) {
					StringWriter errors = new StringWriter();
					e.printStackTrace(new PrintWriter(errors));
					JOptionPane.showMessageDialog(singleFrame,errors.toString());
				}
			}
			
		});
		
		GroupLayout gl_panel_control = new GroupLayout(controlPanel);
		gl_panel_control.setHorizontalGroup(
			gl_panel_control.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_control.createSequentialGroup()
					.addGap(83)
					.addComponent(btn_Exit, GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
					.addGap(18)
					.addComponent(btn_SaveAs, GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
					.addGap(18)
					.addComponent(btn_Save, GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
					.addGap(18)
					.addComponent(btn_startConversion, GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
					.addContainerGap(427, Short.MAX_VALUE))
		);
		gl_panel_control.setVerticalGroup(
			gl_panel_control.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_control.createSequentialGroup()
					.addContainerGap()
					.addGroup(gl_panel_control.createParallelGroup(Alignment.BASELINE)
						.addComponent(btn_SaveAs)
						.addComponent(btn_Save)
						.addComponent(btn_Exit)
						.addComponent(btn_startConversion))
					.addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
		);
						
		controlPanel.setLayout(gl_panel_control);
		return controlPanel;
	}

	public static void runGUI(XComponentContext context) {
		ODTDocument doc = new ODTDocument(context);
		if (singleFrame != null) {
			singleFrame.dispose();
		}
			try {
				UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			} catch (Throwable e) {
				String message = e.getLocalizedMessage();
				JOptionPane.showMessageDialog(singleFrame, message);	
			} 
			EventQueue.invokeLater(new Runnable() {
				public void run() {
					try {
						ConfigurationWindow frame = new ConfigurationWindow(context,doc);
						singleFrame = frame;
						frame.setBounds(100, 100, 1100, 800);
						frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
						frame.setVisible(true);

					} catch (Throwable e) {
						String message = e.getLocalizedMessage();
						JOptionPane.showMessageDialog(singleFrame, message);	
					} 
				}
			});	
		
	}
}
